#!/bin/bash

# This creates version.c from the source code management system.

SOURCEDIR="`dirname $0`/.."
versionfile=$SOURCEDIR/version_stamp.sh

git_modified_exts() {
    git diff --raw HEAD | while read x x x x x f ; do
        f=`basename $f`
        f=`echo $f | sed -e 's/^.*\.//g'`
        echo $f
    done | sort -u
}

if [ -d "$SOURCEDIR/.git" ] ; then
    export GIT="$SOURCEDIR/.git"
    head=$(git rev-parse --short HEAD)
    modifs=$(git_modified_exts | xargs echo)
    info="$head"
    if [ "$modifs" ] ; then
        info="$info + modified $modifs"
    fi
fi

cat > $versionfile <<EOF
# This file is automatically generated.
cmh_long_version="$info"
EOF

# infohash=$(echo $info | sha1sum | cut -d\  -f1)
# 
# if [ -f $versionfile ] && grep -q $infohash $versionfile ; then
#     :
# else
#     echo "version string is now $info"
#     cat > $versionfile <<EOF
# # This file is automatically generated.
# cmh_long_version="$info"
# cmh_version_magic="$infohash"
# EOF
#     # sed -e "s/^cmh_long_version=.*/cmh_long_version=\"$info\"/"   \
#     # -e "s/^cmh_version_magic=.*/cmh_version_magic=$infohash/"       \
#     # -i $versionfile
# fi
