Attach("theta.m");

p:=20;

function makemat(CC)
    i:=CC.1;
    return Matrix(CC,2,2, [(-1+5*i)/2, i/6, i/6, (-1+7*i)/2]);
    // return Matrix(CC,2,2, [(2+10*i)/7, (1+2*i)/6, (1+2*i)/6, 4/10+8*i]);
    /*
    Omega:=Matrix(CC,2,2,
        [CC![2/7, 134/100], CC![3/11,177/1001],
        CC![3/11,177/1001], CC![2/5, 33/4]]);
        */
end function;

/*
for p in [11..21] do
    CC:=ComplexField(2^p : Bits:=true);
    c:=Matrix(CC,4,1,[]);
    z:=Matrix(CC,2,1,[]);
    Omega:=makemat(CC);
    mine, tx:=FourThetas(Omega);
    tx:=ComplexField(5)!tx;
    printf "$\\approx 2^%o$ & %o\n", p, tx;
end for;
*/
for p in [11..21] do
    CC:=ComplexField(2^p : Bits:=true);
    c:=Matrix(CC,4,1,[]);
    z:=Matrix(CC,2,1,[]);
    Omega:=makemat(CC);
    tt:=Cputime();
    magma:=Theta(c,z,Omega);
    tm:=Cputime(tt);
    mine, tx:=FourThetas(Omega);
    mine:=mine[1];
    tx:=ComplexField(5)!tx;
    /* TODO: Go through ThetaSquares_Newton() to get the faster complexity */
    d:=AbsoluteValue(magma-mine);
    if d eq 0 then acc:=Infinity(); else acc:=Floor(-Log(2,d)); end if;
    if tx eq 0 then scale:=Infinity(); else scale:=tm/tx; end if;
    printf "$\\approx 2^%o$ & %o & %o & %o\n", p, tm, tx, acc;
end for;
