
/* No, really, I shouldn't have to write this. */
function parserealnumber(s, CC)
    foo:=s;
    k:=1;
    while k le #foo and foo[k] eq " " do k+:=1; end while;
    if k le #foo then
        foo:=Substring(foo, k, #foo+1-k); k:=1;
    else
        foo:="";
    end if;
    s:=1;
    if Regexp("^@NaN@", foo) then 
        error "output string contains Nan, unsupported: " cat foo;
    end if;
    t, seg, parts:=Regexp("^(-?[0-9]+)\\.([0-9]*)", foo);
    if t then
        a,b:=Explode(parts);
        m:=StringToInteger(a);
        s:=a[1] eq "-" select -1 else 1;        // avoid 0
        m*:=s;
        m+:=StringToInteger(b)/10^#b;
    else
        t, seg, parts:=Regexp("^(-?[0-9]+)", foo);
        if t then
            a:=Explode(parts);
            m:=StringToInteger(a);
            s:=a[1] eq "-" select -1 else 1;        // avoid 0
            m*:=s;
        else
            t, seg, parts:=Regexp("(-?)\\.([0-9]*)", foo);
            assert t; /* we're in trouble here */
            a,b:=Explode(parts);
            m:=StringToInteger(b)/10^#b;
            s:=StringToInteger(a cat "1");
        end if;
    end if;
    m*:=s;
    k+:=#seg;
    if k le #foo then
        foo:=Substring(foo, k, #foo+1-k); k:=1;
    else
        foo:="";
    end if;
    t, seg, parts := Regexp("^[eE](-?[0-9]+)", foo);
    if t then
        e:=StringToInteger(parts[1]);
        m*:=10^e;
        k+:=#seg;
        if k le #foo then
            foo:=Substring(foo, k, #foo+1-k); k:=1;
        else
            foo:="";
        end if;
    end if;
    return CC!m, foo;
end function;

function output_to_complex_vector(output, CC)
    k:=1;
    L:=[];
    foo:=output;
    tm:=0;
    while k le #foo do
        if foo[k] ne "(" then
            /* timing info */
            foo:=Substring(foo, k, #foo+1-k); k:=1;
            tm, foo:=parserealnumber(foo, CC);
            assert foo[k] eq "\n"; k+:=1;
            assert k gt #foo;
            break;
        end if;
        assert foo[k] eq "(";
        k+:=1;
        foo:=Substring(foo, k, #foo+1-k); k:=1;
        rr, foo:=parserealnumber(foo, CC);
        ii, foo:=parserealnumber(foo, CC);
        assert foo[k] eq ")"; k+:=1;
        assert foo[k] eq "\n"; k+:=1;
        Append(~L, CC![rr,ii]);
    end while;
    return Vector(L), tm;
end function;

function input_from_complex_vector(vec)
    return &cat [Sprintf("(%o %o)\n", Real(t), Imaginary(t)) : t in Eltseq(vec)];
end function;

function period_matrix_to_something_from_thetatool(tau, something)
    CC:=CoefficientRing(tau);
    input:=input_from_complex_vector([tau[1,1], tau[1,2], tau[2,2]]);
    /*
    print "./thetatool time " cat
    something cat " " cat IntegerToString(BitPrecision(CC));
    print input;
    */
    output := Pipe( "./thetatool time " cat
    something cat " " cat IntegerToString(BitPrecision(CC)), input);
    v,tm:=output_to_complex_vector(output, CC);
    return v,tm;
end function;

intrinsic ThetaSquares(tau :: AlgMatElt) -> ModTupFldElt, FldReElt
{ compute the 10 squares of the fundamental theta constants associated to the
  period matrix tau }
    return period_matrix_to_something_from_thetatool(tau, "10theta2");
end intrinsic;

intrinsic ThetaSquares_Newton(tau :: AlgMatElt) -> ModTupFldElt, FldReElt
{ compute the 10 squares of the fundamental theta constants associated to the
  period matrix tau }
    return period_matrix_to_something_from_thetatool(tau, "10theta2_newton");
end intrinsic;

intrinsic FourThetas(tau :: AlgMatElt) -> ModTupFldElt, FldReElt
{ compute the 4 fundamental theta constants associated to the
  period matrix tau }
    v,tm:=period_matrix_to_something_from_thetatool(tau, "4theta");
    return v,tm;
end intrinsic;

intrinsic StrengInvariants(tau :: AlgMatElt) -> ModTupFldElt
{ compute the Streng j1,j2,j3 invariangs associated to the
  period matrix tau }
    return period_matrix_to_something_from_thetatool(tau, "streng");
end intrinsic;

intrinsic BorchardtMean(v :: ModTupFldElt) -> FldComElt
{ Compute the Borchardt mean of the four complex numbers }
    vs:=Eltseq(v);
    require #vs eq 4 : "v should be an element in C^4";
    CC:=CoefficientRing(v);
    input:=input_from_complex_vector(v);
    output := Pipe("./thetatool " cat "b2" cat " " cat IntegerToString(BitPrecision(CC)), input);
    return output_to_complex_vector(output, CC)[1];
end intrinsic;

intrinsic Duplication_10x_from_3q(v :: ModTupFldElt) -> ModTupFldElt
{ Duplication formulae: 10 theta squares at Omega from 4 thetas at Omega/2 --
  except that we're taking quotient by the first theta constant at Omega/2, so
  we have in effect only one variable. The projective factor is not computed,
  so the result is only projectively equivalent to the vector of 10 theta
  squares at theta.
}
    vs:=Eltseq(v);
    require #vs eq 3 : "v should be an element in C^3";
    CC:=CoefficientRing(v);
    input:=input_from_complex_vector(v);
    output := Pipe("./thetatool " cat "10theta2x_from_3thetaqtauhalf" cat " " cat IntegerToString(BitPrecision(CC)), input);
    return output_to_complex_vector(output, CC);
end intrinsic;

